public class ToHtmlConvertor implements TraversalUtil.Callback
{
	public Style getParagraphStyle(P paragraph)
	{
		PPrBase.PStyle pStyle = paragraph.getPPr().getPStyle();
		
		if (pStyle != null) {
			return stylesPart.getStyleById(pStyle.getVal()); // stylesPart var has the Styles Part of our document
		}
		
		return null;
	}
		
	public PPrBase.NumPr getParagraphNumbering(P paragraph)
	{
		PPrBase.NumPr numPr = paragraph.getPPr().getNumPr();
		
		if (numPr == null) {
			Style style = getParagraphStyle(paragraph);

			if (style != null) {
				numPr = style.getPPr().getNumPr();
			}
		}
		
		return numPr;
	}

	public String getNumberingString(P p)
	{
		String result = "";
		PPrBase.NumPr numPr = document.getParagraphNumbering(p);
		
		if (numPr != null) {
			PPrBase.NumPr.NumId numId = numPr.getNumId();
			String pStyleVal = p.getPPr().getPStyle().getVal();
			
			Emulator.ResultTriple number = Emulator.getNumber(
				document.wmlPackage,
				pStyleVal,
				numId == null ? null : numId.getVal().toString(),
				numPr.getIlvl().getVal().toString()
			);
			
			if (number != null) {
				result = number.getNumString(); // here we start to get wrong strings after the 9-th paragraph
			}
		}
		
		result = result == null ? "" : result;
		return result;
	}
	
	//... other methods
}